/*
  Persistence of Vision Ray Tracer Scene Description File
  
  Wide Gamut color spaces test
  
*/

#version 3.6;      

global_settings {assumed_gamma 2.2}            
#default {finish {ambient 1 diffuse 0}} 
        
#include "colors.inc"

#include "CIE.inc"

// Wide Gamut and ProPhoto color space systems, values by 
// Bruce Lindbloom:
// www.brucelindbloom.com/index.html?WorkingSpaceInfo.html  
#include "CIE_wide-gamut_ColSys.inc"

//CIE_ColorSystem(sRGB_ColSys) // <- default
CIE_ColorSystem(WideGamut_ColSys)
//CIE_ColorSystem(ProPhoto_ColSys)

CIE_ChromaticAdaption(off)
//CIE_ChromaticAdaption(VonKries_ChromaMatch)
//CIE_ChromaticAdaption(Bradford_ChromaMatch) // <- default 

CIE_GamutMapping(0); // 0=off, 1=clipping, 2=RGB triangle intersection

//=========================================================

// put random blobs filling the color space
#declare Lab_L=0;
#declare Lab_a=-128;
#declare lab_b=-128;
#declare r_lab=seed(55);
#declare i_samples=0;
#declare num_samples=2000;
union{
blob{threshold .5
#while (i_samples<=num_samples)
 #declare test_Lab=<100*rand(r_lab),-128+255*rand(r_lab),-128+255*rand(r_lab)>;
 #declare RGB_color=MapGamut(Lab2RGB(test_Lab));
 /*
 #debug str(RGB_color.x,16,8)
 #debug " "
 #debug str(RGB_color.y,16,8)
 #debug " "
 #debug str(RGB_color.z,16,8)
 #debug "\n"
 */
// #if (min(RGB_color.red, RGB_color.green, RGB_color.blue) >= 0.0) // inside gamut?
 sphere{0,4,1
  pigment{rgb RGB_color}
  translate test_Lab
  translate -50*x
 }
// #end // gamut test
 #declare i_samples=i_samples+1;
#end
}
 difference{
  box{-.5,.5}
  box{-.5,.5 scale <1.01,.99,.99>}
  box{-.5,.5 scale <.99,1.01,.99>}
  box{-.5,.5 scale <.99,.99,1.01>}
  scale <100,255,255>
  pigment{rgb ReferenceRGB(White)}
 }
 rotate 90*z
 rotate 45
 rotate 360*x*clock
}

camera{    
  location -400*z 
  look_at 0
}
